// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/CameraIO.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/camera_io.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'configured'
#include "sick_safevisionary_interfaces/msg/detail/io_configured__struct.hpp"
// Member 'direction'
#include "sick_safevisionary_interfaces/msg/detail/io_direction__struct.hpp"
// Member 'input_values'
#include "sick_safevisionary_interfaces/msg/detail/io_input_values__struct.hpp"
// Member 'output_values'
#include "sick_safevisionary_interfaces/msg/detail/io_output_values__struct.hpp"
// Member 'ossds_state'
#include "sick_safevisionary_interfaces/msg/detail/ioossds_state__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__CameraIO __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__CameraIO __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CameraIO_
{
  using Type = CameraIO_<ContainerAllocator>;

  explicit CameraIO_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    configured(_init),
    direction(_init),
    input_values(_init),
    output_values(_init),
    ossds_state(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ossds_dyn_count = 0;
      this->ossds_crc = 0;
      this->ossds_io_status = 0;
      this->dynamic_speed_a = 0;
      this->dynamic_speed_b = 0;
      this->dynamic_valid_flags = 0;
    }
  }

  explicit CameraIO_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    configured(_alloc, _init),
    direction(_alloc, _init),
    input_values(_alloc, _init),
    output_values(_alloc, _init),
    ossds_state(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ossds_dyn_count = 0;
      this->ossds_crc = 0;
      this->ossds_io_status = 0;
      this->dynamic_speed_a = 0;
      this->dynamic_speed_b = 0;
      this->dynamic_valid_flags = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _configured_type =
    sick_safevisionary_interfaces::msg::IOConfigured_<ContainerAllocator>;
  _configured_type configured;
  using _direction_type =
    sick_safevisionary_interfaces::msg::IODirection_<ContainerAllocator>;
  _direction_type direction;
  using _input_values_type =
    sick_safevisionary_interfaces::msg::IOInputValues_<ContainerAllocator>;
  _input_values_type input_values;
  using _output_values_type =
    sick_safevisionary_interfaces::msg::IOOutputValues_<ContainerAllocator>;
  _output_values_type output_values;
  using _ossds_state_type =
    sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>;
  _ossds_state_type ossds_state;
  using _ossds_dyn_count_type =
    uint8_t;
  _ossds_dyn_count_type ossds_dyn_count;
  using _ossds_crc_type =
    uint8_t;
  _ossds_crc_type ossds_crc;
  using _ossds_io_status_type =
    uint8_t;
  _ossds_io_status_type ossds_io_status;
  using _dynamic_speed_a_type =
    uint16_t;
  _dynamic_speed_a_type dynamic_speed_a;
  using _dynamic_speed_b_type =
    uint16_t;
  _dynamic_speed_b_type dynamic_speed_b;
  using _dynamic_valid_flags_type =
    uint16_t;
  _dynamic_valid_flags_type dynamic_valid_flags;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__configured(
    const sick_safevisionary_interfaces::msg::IOConfigured_<ContainerAllocator> & _arg)
  {
    this->configured = _arg;
    return *this;
  }
  Type & set__direction(
    const sick_safevisionary_interfaces::msg::IODirection_<ContainerAllocator> & _arg)
  {
    this->direction = _arg;
    return *this;
  }
  Type & set__input_values(
    const sick_safevisionary_interfaces::msg::IOInputValues_<ContainerAllocator> & _arg)
  {
    this->input_values = _arg;
    return *this;
  }
  Type & set__output_values(
    const sick_safevisionary_interfaces::msg::IOOutputValues_<ContainerAllocator> & _arg)
  {
    this->output_values = _arg;
    return *this;
  }
  Type & set__ossds_state(
    const sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> & _arg)
  {
    this->ossds_state = _arg;
    return *this;
  }
  Type & set__ossds_dyn_count(
    const uint8_t & _arg)
  {
    this->ossds_dyn_count = _arg;
    return *this;
  }
  Type & set__ossds_crc(
    const uint8_t & _arg)
  {
    this->ossds_crc = _arg;
    return *this;
  }
  Type & set__ossds_io_status(
    const uint8_t & _arg)
  {
    this->ossds_io_status = _arg;
    return *this;
  }
  Type & set__dynamic_speed_a(
    const uint16_t & _arg)
  {
    this->dynamic_speed_a = _arg;
    return *this;
  }
  Type & set__dynamic_speed_b(
    const uint16_t & _arg)
  {
    this->dynamic_speed_b = _arg;
    return *this;
  }
  Type & set__dynamic_valid_flags(
    const uint16_t & _arg)
  {
    this->dynamic_valid_flags = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__CameraIO
    std::shared_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__CameraIO
    std::shared_ptr<sick_safevisionary_interfaces::msg::CameraIO_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraIO_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->configured != other.configured) {
      return false;
    }
    if (this->direction != other.direction) {
      return false;
    }
    if (this->input_values != other.input_values) {
      return false;
    }
    if (this->output_values != other.output_values) {
      return false;
    }
    if (this->ossds_state != other.ossds_state) {
      return false;
    }
    if (this->ossds_dyn_count != other.ossds_dyn_count) {
      return false;
    }
    if (this->ossds_crc != other.ossds_crc) {
      return false;
    }
    if (this->ossds_io_status != other.ossds_io_status) {
      return false;
    }
    if (this->dynamic_speed_a != other.dynamic_speed_a) {
      return false;
    }
    if (this->dynamic_speed_b != other.dynamic_speed_b) {
      return false;
    }
    if (this->dynamic_valid_flags != other.dynamic_valid_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraIO_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraIO_

// alias to use template instance with default allocator
using CameraIO =
  sick_safevisionary_interfaces::msg::CameraIO_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__STRUCT_HPP_
