// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/GeneralStatus.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/general_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
sick_safevisionary_interfaces__msg__GeneralStatus__init(sick_safevisionary_interfaces__msg__GeneralStatus * msg)
{
  if (!msg) {
    return false;
  }
  // run_mode_active
  // device_error
  // application_error
  // sleep_mode
  // wait_for_input
  // wait_for_cluster
  // contamination_warning
  // contamination_error
  // dead_zone_detection
  // temperature_warning
  return true;
}

void
sick_safevisionary_interfaces__msg__GeneralStatus__fini(sick_safevisionary_interfaces__msg__GeneralStatus * msg)
{
  if (!msg) {
    return;
  }
  // run_mode_active
  // device_error
  // application_error
  // sleep_mode
  // wait_for_input
  // wait_for_cluster
  // contamination_warning
  // contamination_error
  // dead_zone_detection
  // temperature_warning
}

bool
sick_safevisionary_interfaces__msg__GeneralStatus__are_equal(const sick_safevisionary_interfaces__msg__GeneralStatus * lhs, const sick_safevisionary_interfaces__msg__GeneralStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // run_mode_active
  if (lhs->run_mode_active != rhs->run_mode_active) {
    return false;
  }
  // device_error
  if (lhs->device_error != rhs->device_error) {
    return false;
  }
  // application_error
  if (lhs->application_error != rhs->application_error) {
    return false;
  }
  // sleep_mode
  if (lhs->sleep_mode != rhs->sleep_mode) {
    return false;
  }
  // wait_for_input
  if (lhs->wait_for_input != rhs->wait_for_input) {
    return false;
  }
  // wait_for_cluster
  if (lhs->wait_for_cluster != rhs->wait_for_cluster) {
    return false;
  }
  // contamination_warning
  if (lhs->contamination_warning != rhs->contamination_warning) {
    return false;
  }
  // contamination_error
  if (lhs->contamination_error != rhs->contamination_error) {
    return false;
  }
  // dead_zone_detection
  if (lhs->dead_zone_detection != rhs->dead_zone_detection) {
    return false;
  }
  // temperature_warning
  if (lhs->temperature_warning != rhs->temperature_warning) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__GeneralStatus__copy(
  const sick_safevisionary_interfaces__msg__GeneralStatus * input,
  sick_safevisionary_interfaces__msg__GeneralStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // run_mode_active
  output->run_mode_active = input->run_mode_active;
  // device_error
  output->device_error = input->device_error;
  // application_error
  output->application_error = input->application_error;
  // sleep_mode
  output->sleep_mode = input->sleep_mode;
  // wait_for_input
  output->wait_for_input = input->wait_for_input;
  // wait_for_cluster
  output->wait_for_cluster = input->wait_for_cluster;
  // contamination_warning
  output->contamination_warning = input->contamination_warning;
  // contamination_error
  output->contamination_error = input->contamination_error;
  // dead_zone_detection
  output->dead_zone_detection = input->dead_zone_detection;
  // temperature_warning
  output->temperature_warning = input->temperature_warning;
  return true;
}

sick_safevisionary_interfaces__msg__GeneralStatus *
sick_safevisionary_interfaces__msg__GeneralStatus__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__GeneralStatus * msg = (sick_safevisionary_interfaces__msg__GeneralStatus *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__GeneralStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__GeneralStatus));
  bool success = sick_safevisionary_interfaces__msg__GeneralStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__GeneralStatus__destroy(sick_safevisionary_interfaces__msg__GeneralStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__GeneralStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__init(sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__GeneralStatus * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__GeneralStatus *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__GeneralStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__GeneralStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__GeneralStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__fini(sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__GeneralStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__GeneralStatus__Sequence *
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * array = (sick_safevisionary_interfaces__msg__GeneralStatus__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__GeneralStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__destroy(sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__are_equal(const sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * lhs, const sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__GeneralStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__GeneralStatus__Sequence__copy(
  const sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * input,
  sick_safevisionary_interfaces__msg__GeneralStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__GeneralStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__GeneralStatus * data =
      (sick_safevisionary_interfaces__msg__GeneralStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__GeneralStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__GeneralStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__GeneralStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
