// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/GeneralStatus.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/general_status.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__GeneralStatus __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__GeneralStatus __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeneralStatus_
{
  using Type = GeneralStatus_<ContainerAllocator>;

  explicit GeneralStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->run_mode_active = 0;
      this->device_error = 0;
      this->application_error = 0;
      this->sleep_mode = 0;
      this->wait_for_input = 0;
      this->wait_for_cluster = 0;
      this->contamination_warning = 0;
      this->contamination_error = 0;
      this->dead_zone_detection = 0;
      this->temperature_warning = 0;
    }
  }

  explicit GeneralStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->run_mode_active = 0;
      this->device_error = 0;
      this->application_error = 0;
      this->sleep_mode = 0;
      this->wait_for_input = 0;
      this->wait_for_cluster = 0;
      this->contamination_warning = 0;
      this->contamination_error = 0;
      this->dead_zone_detection = 0;
      this->temperature_warning = 0;
    }
  }

  // field types and members
  using _run_mode_active_type =
    uint8_t;
  _run_mode_active_type run_mode_active;
  using _device_error_type =
    uint8_t;
  _device_error_type device_error;
  using _application_error_type =
    uint8_t;
  _application_error_type application_error;
  using _sleep_mode_type =
    uint8_t;
  _sleep_mode_type sleep_mode;
  using _wait_for_input_type =
    uint8_t;
  _wait_for_input_type wait_for_input;
  using _wait_for_cluster_type =
    uint8_t;
  _wait_for_cluster_type wait_for_cluster;
  using _contamination_warning_type =
    uint8_t;
  _contamination_warning_type contamination_warning;
  using _contamination_error_type =
    uint8_t;
  _contamination_error_type contamination_error;
  using _dead_zone_detection_type =
    uint8_t;
  _dead_zone_detection_type dead_zone_detection;
  using _temperature_warning_type =
    uint8_t;
  _temperature_warning_type temperature_warning;

  // setters for named parameter idiom
  Type & set__run_mode_active(
    const uint8_t & _arg)
  {
    this->run_mode_active = _arg;
    return *this;
  }
  Type & set__device_error(
    const uint8_t & _arg)
  {
    this->device_error = _arg;
    return *this;
  }
  Type & set__application_error(
    const uint8_t & _arg)
  {
    this->application_error = _arg;
    return *this;
  }
  Type & set__sleep_mode(
    const uint8_t & _arg)
  {
    this->sleep_mode = _arg;
    return *this;
  }
  Type & set__wait_for_input(
    const uint8_t & _arg)
  {
    this->wait_for_input = _arg;
    return *this;
  }
  Type & set__wait_for_cluster(
    const uint8_t & _arg)
  {
    this->wait_for_cluster = _arg;
    return *this;
  }
  Type & set__contamination_warning(
    const uint8_t & _arg)
  {
    this->contamination_warning = _arg;
    return *this;
  }
  Type & set__contamination_error(
    const uint8_t & _arg)
  {
    this->contamination_error = _arg;
    return *this;
  }
  Type & set__dead_zone_detection(
    const uint8_t & _arg)
  {
    this->dead_zone_detection = _arg;
    return *this;
  }
  Type & set__temperature_warning(
    const uint8_t & _arg)
  {
    this->temperature_warning = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__GeneralStatus
    std::shared_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__GeneralStatus
    std::shared_ptr<sick_safevisionary_interfaces::msg::GeneralStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeneralStatus_ & other) const
  {
    if (this->run_mode_active != other.run_mode_active) {
      return false;
    }
    if (this->device_error != other.device_error) {
      return false;
    }
    if (this->application_error != other.application_error) {
      return false;
    }
    if (this->sleep_mode != other.sleep_mode) {
      return false;
    }
    if (this->wait_for_input != other.wait_for_input) {
      return false;
    }
    if (this->wait_for_cluster != other.wait_for_cluster) {
      return false;
    }
    if (this->contamination_warning != other.contamination_warning) {
      return false;
    }
    if (this->contamination_error != other.contamination_error) {
      return false;
    }
    if (this->dead_zone_detection != other.dead_zone_detection) {
      return false;
    }
    if (this->temperature_warning != other.temperature_warning) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeneralStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeneralStatus_

// alias to use template instance with default allocator
using GeneralStatus =
  sick_safevisionary_interfaces::msg::GeneralStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__GENERAL_STATUS__STRUCT_HPP_
