// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/IOOSSDSState.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/ioossds_state.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__IOOSSDS_STATE__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__IOOSSDS_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__IOOSSDSState __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__IOOSSDSState __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IOOSSDSState_
{
  using Type = IOOSSDSState_<ContainerAllocator>;

  explicit IOOSSDSState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ossd1a = 0;
      this->ossd1b = 0;
      this->ossd2a = 0;
      this->ossd2b = 0;
    }
  }

  explicit IOOSSDSState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ossd1a = 0;
      this->ossd1b = 0;
      this->ossd2a = 0;
      this->ossd2b = 0;
    }
  }

  // field types and members
  using _ossd1a_type =
    uint8_t;
  _ossd1a_type ossd1a;
  using _ossd1b_type =
    uint8_t;
  _ossd1b_type ossd1b;
  using _ossd2a_type =
    uint8_t;
  _ossd2a_type ossd2a;
  using _ossd2b_type =
    uint8_t;
  _ossd2b_type ossd2b;

  // setters for named parameter idiom
  Type & set__ossd1a(
    const uint8_t & _arg)
  {
    this->ossd1a = _arg;
    return *this;
  }
  Type & set__ossd1b(
    const uint8_t & _arg)
  {
    this->ossd1b = _arg;
    return *this;
  }
  Type & set__ossd2a(
    const uint8_t & _arg)
  {
    this->ossd2a = _arg;
    return *this;
  }
  Type & set__ossd2b(
    const uint8_t & _arg)
  {
    this->ossd2b = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__IOOSSDSState
    std::shared_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__IOOSSDSState
    std::shared_ptr<sick_safevisionary_interfaces::msg::IOOSSDSState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IOOSSDSState_ & other) const
  {
    if (this->ossd1a != other.ossd1a) {
      return false;
    }
    if (this->ossd1b != other.ossd1b) {
      return false;
    }
    if (this->ossd2a != other.ossd2a) {
      return false;
    }
    if (this->ossd2b != other.ossd2b) {
      return false;
    }
    return true;
  }
  bool operator!=(const IOOSSDSState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IOOSSDSState_

// alias to use template instance with default allocator
using IOOSSDSState =
  sick_safevisionary_interfaces::msg::IOOSSDSState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__IOOSSDS_STATE__STRUCT_HPP_
