// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/ROI.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/roi.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'result_data'
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_result_data__struct.hpp"
// Member 'safety_data'
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_safety_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROI __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROI __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ROI_
{
  using Type = ROI_<ContainerAllocator>;

  explicit ROI_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result_data(_init),
    safety_data(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->distance_value = 0;
    }
  }

  explicit ROI_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result_data(_alloc, _init),
    safety_data(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->distance_value = 0;
    }
  }

  // field types and members
  using _id_type =
    uint8_t;
  _id_type id;
  using _result_data_type =
    sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>;
  _result_data_type result_data;
  using _safety_data_type =
    sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator>;
  _safety_data_type safety_data;
  using _distance_value_type =
    uint16_t;
  _distance_value_type distance_value;

  // setters for named parameter idiom
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__result_data(
    const sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> & _arg)
  {
    this->result_data = _arg;
    return *this;
  }
  Type & set__safety_data(
    const sick_safevisionary_interfaces::msg::ROIObservationSafetyData_<ContainerAllocator> & _arg)
  {
    this->safety_data = _arg;
    return *this;
  }
  Type & set__distance_value(
    const uint16_t & _arg)
  {
    this->distance_value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROI
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROI
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROI_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROI_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->result_data != other.result_data) {
      return false;
    }
    if (this->safety_data != other.safety_data) {
      return false;
    }
    if (this->distance_value != other.distance_value) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROI_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROI_

// alias to use template instance with default allocator
using ROI =
  sick_safevisionary_interfaces::msg::ROI_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI__STRUCT_HPP_
