// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/ROIObservationResultData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/roi_observation_result_data.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_RESULT_DATA__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_RESULT_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationResultData __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationResultData __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ROIObservationResultData_
{
  using Type = ROIObservationResultData_<ContainerAllocator>;

  explicit ROIObservationResultData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->task_result = 0;
      this->result_safe = 0;
      this->result_valid = 0;
      this->distance_valid = 0;
      this->distance_safe = 0;
    }
  }

  explicit ROIObservationResultData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->task_result = 0;
      this->result_safe = 0;
      this->result_valid = 0;
      this->distance_valid = 0;
      this->distance_safe = 0;
    }
  }

  // field types and members
  using _task_result_type =
    uint8_t;
  _task_result_type task_result;
  using _result_safe_type =
    uint8_t;
  _result_safe_type result_safe;
  using _result_valid_type =
    uint8_t;
  _result_valid_type result_valid;
  using _distance_valid_type =
    uint8_t;
  _distance_valid_type distance_valid;
  using _distance_safe_type =
    uint8_t;
  _distance_safe_type distance_safe;

  // setters for named parameter idiom
  Type & set__task_result(
    const uint8_t & _arg)
  {
    this->task_result = _arg;
    return *this;
  }
  Type & set__result_safe(
    const uint8_t & _arg)
  {
    this->result_safe = _arg;
    return *this;
  }
  Type & set__result_valid(
    const uint8_t & _arg)
  {
    this->result_valid = _arg;
    return *this;
  }
  Type & set__distance_valid(
    const uint8_t & _arg)
  {
    this->distance_valid = _arg;
    return *this;
  }
  Type & set__distance_safe(
    const uint8_t & _arg)
  {
    this->distance_safe = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationResultData
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__ROIObservationResultData
    std::shared_ptr<sick_safevisionary_interfaces::msg::ROIObservationResultData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROIObservationResultData_ & other) const
  {
    if (this->task_result != other.task_result) {
      return false;
    }
    if (this->result_safe != other.result_safe) {
      return false;
    }
    if (this->result_valid != other.result_valid) {
      return false;
    }
    if (this->distance_valid != other.distance_valid) {
      return false;
    }
    if (this->distance_safe != other.distance_safe) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROIObservationResultData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROIObservationResultData_

// alias to use template instance with default allocator
using ROIObservationResultData =
  sick_safevisionary_interfaces::msg::ROIObservationResultData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__ROI_OBSERVATION_RESULT_DATA__STRUCT_HPP_
