// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/CameraIO.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/camera_io.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/camera_io__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'configured'
#include "sick_safevisionary_interfaces/msg/detail/io_configured__traits.hpp"
// Member 'direction'
#include "sick_safevisionary_interfaces/msg/detail/io_direction__traits.hpp"
// Member 'input_values'
#include "sick_safevisionary_interfaces/msg/detail/io_input_values__traits.hpp"
// Member 'output_values'
#include "sick_safevisionary_interfaces/msg/detail/io_output_values__traits.hpp"
// Member 'ossds_state'
#include "sick_safevisionary_interfaces/msg/detail/ioossds_state__traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const CameraIO & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: configured
  {
    out << "configured: ";
    to_flow_style_yaml(msg.configured, out);
    out << ", ";
  }

  // member: direction
  {
    out << "direction: ";
    to_flow_style_yaml(msg.direction, out);
    out << ", ";
  }

  // member: input_values
  {
    out << "input_values: ";
    to_flow_style_yaml(msg.input_values, out);
    out << ", ";
  }

  // member: output_values
  {
    out << "output_values: ";
    to_flow_style_yaml(msg.output_values, out);
    out << ", ";
  }

  // member: ossds_state
  {
    out << "ossds_state: ";
    to_flow_style_yaml(msg.ossds_state, out);
    out << ", ";
  }

  // member: ossds_dyn_count
  {
    out << "ossds_dyn_count: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_dyn_count, out);
    out << ", ";
  }

  // member: ossds_crc
  {
    out << "ossds_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_crc, out);
    out << ", ";
  }

  // member: ossds_io_status
  {
    out << "ossds_io_status: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_io_status, out);
    out << ", ";
  }

  // member: dynamic_speed_a
  {
    out << "dynamic_speed_a: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_speed_a, out);
    out << ", ";
  }

  // member: dynamic_speed_b
  {
    out << "dynamic_speed_b: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_speed_b, out);
    out << ", ";
  }

  // member: dynamic_valid_flags
  {
    out << "dynamic_valid_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_valid_flags, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: configured
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "configured:\n";
    to_block_style_yaml(msg.configured, out, indentation + 2);
  }

  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction:\n";
    to_block_style_yaml(msg.direction, out, indentation + 2);
  }

  // member: input_values
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "input_values:\n";
    to_block_style_yaml(msg.input_values, out, indentation + 2);
  }

  // member: output_values
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "output_values:\n";
    to_block_style_yaml(msg.output_values, out, indentation + 2);
  }

  // member: ossds_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ossds_state:\n";
    to_block_style_yaml(msg.ossds_state, out, indentation + 2);
  }

  // member: ossds_dyn_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ossds_dyn_count: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_dyn_count, out);
    out << "\n";
  }

  // member: ossds_crc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ossds_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_crc, out);
    out << "\n";
  }

  // member: ossds_io_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ossds_io_status: ";
    rosidl_generator_traits::value_to_yaml(msg.ossds_io_status, out);
    out << "\n";
  }

  // member: dynamic_speed_a
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamic_speed_a: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_speed_a, out);
    out << "\n";
  }

  // member: dynamic_speed_b
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamic_speed_b: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_speed_b, out);
    out << "\n";
  }

  // member: dynamic_valid_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamic_valid_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamic_valid_flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraIO & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::CameraIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::CameraIO & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::CameraIO>()
{
  return "sick_safevisionary_interfaces::msg::CameraIO";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::CameraIO>()
{
  return "sick_safevisionary_interfaces/msg/CameraIO";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::CameraIO>
  : std::integral_constant<bool, has_fixed_size<sick_safevisionary_interfaces::msg::IOConfigured>::value && has_fixed_size<sick_safevisionary_interfaces::msg::IODirection>::value && has_fixed_size<sick_safevisionary_interfaces::msg::IOInputValues>::value && has_fixed_size<sick_safevisionary_interfaces::msg::IOOSSDSState>::value && has_fixed_size<sick_safevisionary_interfaces::msg::IOOutputValues>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::CameraIO>
  : std::integral_constant<bool, has_bounded_size<sick_safevisionary_interfaces::msg::IOConfigured>::value && has_bounded_size<sick_safevisionary_interfaces::msg::IODirection>::value && has_bounded_size<sick_safevisionary_interfaces::msg::IOInputValues>::value && has_bounded_size<sick_safevisionary_interfaces::msg::IOOSSDSState>::value && has_bounded_size<sick_safevisionary_interfaces::msg::IOOutputValues>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::CameraIO>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__CAMERA_IO__TRAITS_HPP_
