// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sick_safevisionary_interfaces:msg/FieldInformation.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/field_information.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__STRUCT_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sick_safevisionary_interfaces__msg__FieldInformation __attribute__((deprecated))
#else
# define DEPRECATED__sick_safevisionary_interfaces__msg__FieldInformation __declspec(deprecated)
#endif

namespace sick_safevisionary_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FieldInformation_
{
  using Type = FieldInformation_<ContainerAllocator>;

  explicit FieldInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->field_id = 0;
      this->field_set_id = 0;
      this->field_result = 0;
      this->eval_method = 0;
      this->field_active = 0;
    }
  }

  explicit FieldInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->field_id = 0;
      this->field_set_id = 0;
      this->field_result = 0;
      this->eval_method = 0;
      this->field_active = 0;
    }
  }

  // field types and members
  using _field_id_type =
    uint8_t;
  _field_id_type field_id;
  using _field_set_id_type =
    uint8_t;
  _field_set_id_type field_set_id;
  using _field_result_type =
    uint8_t;
  _field_result_type field_result;
  using _eval_method_type =
    uint8_t;
  _eval_method_type eval_method;
  using _field_active_type =
    uint8_t;
  _field_active_type field_active;

  // setters for named parameter idiom
  Type & set__field_id(
    const uint8_t & _arg)
  {
    this->field_id = _arg;
    return *this;
  }
  Type & set__field_set_id(
    const uint8_t & _arg)
  {
    this->field_set_id = _arg;
    return *this;
  }
  Type & set__field_result(
    const uint8_t & _arg)
  {
    this->field_result = _arg;
    return *this;
  }
  Type & set__eval_method(
    const uint8_t & _arg)
  {
    this->eval_method = _arg;
    return *this;
  }
  Type & set__field_active(
    const uint8_t & _arg)
  {
    this->field_active = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__FieldInformation
    std::shared_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sick_safevisionary_interfaces__msg__FieldInformation
    std::shared_ptr<sick_safevisionary_interfaces::msg::FieldInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FieldInformation_ & other) const
  {
    if (this->field_id != other.field_id) {
      return false;
    }
    if (this->field_set_id != other.field_set_id) {
      return false;
    }
    if (this->field_result != other.field_result) {
      return false;
    }
    if (this->eval_method != other.eval_method) {
      return false;
    }
    if (this->field_active != other.field_active) {
      return false;
    }
    return true;
  }
  bool operator!=(const FieldInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FieldInformation_

// alias to use template instance with default allocator
using FieldInformation =
  sick_safevisionary_interfaces::msg::FieldInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__STRUCT_HPP_
