// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sick_safevisionary_interfaces:msg/FieldInformation.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sick_safevisionary_interfaces/msg/field_information.hpp"


#ifndef SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__TRAITS_HPP_
#define SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sick_safevisionary_interfaces/msg/detail/field_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sick_safevisionary_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FieldInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: field_id
  {
    out << "field_id: ";
    rosidl_generator_traits::value_to_yaml(msg.field_id, out);
    out << ", ";
  }

  // member: field_set_id
  {
    out << "field_set_id: ";
    rosidl_generator_traits::value_to_yaml(msg.field_set_id, out);
    out << ", ";
  }

  // member: field_result
  {
    out << "field_result: ";
    rosidl_generator_traits::value_to_yaml(msg.field_result, out);
    out << ", ";
  }

  // member: eval_method
  {
    out << "eval_method: ";
    rosidl_generator_traits::value_to_yaml(msg.eval_method, out);
    out << ", ";
  }

  // member: field_active
  {
    out << "field_active: ";
    rosidl_generator_traits::value_to_yaml(msg.field_active, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FieldInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: field_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "field_id: ";
    rosidl_generator_traits::value_to_yaml(msg.field_id, out);
    out << "\n";
  }

  // member: field_set_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "field_set_id: ";
    rosidl_generator_traits::value_to_yaml(msg.field_set_id, out);
    out << "\n";
  }

  // member: field_result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "field_result: ";
    rosidl_generator_traits::value_to_yaml(msg.field_result, out);
    out << "\n";
  }

  // member: eval_method
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "eval_method: ";
    rosidl_generator_traits::value_to_yaml(msg.eval_method, out);
    out << "\n";
  }

  // member: field_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "field_active: ";
    rosidl_generator_traits::value_to_yaml(msg.field_active, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FieldInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use sick_safevisionary_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sick_safevisionary_interfaces::msg::FieldInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  sick_safevisionary_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sick_safevisionary_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const sick_safevisionary_interfaces::msg::FieldInformation & msg)
{
  return sick_safevisionary_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sick_safevisionary_interfaces::msg::FieldInformation>()
{
  return "sick_safevisionary_interfaces::msg::FieldInformation";
}

template<>
inline const char * name<sick_safevisionary_interfaces::msg::FieldInformation>()
{
  return "sick_safevisionary_interfaces/msg/FieldInformation";
}

template<>
struct has_fixed_size<sick_safevisionary_interfaces::msg::FieldInformation>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<sick_safevisionary_interfaces::msg::FieldInformation>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<sick_safevisionary_interfaces::msg::FieldInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SICK_SAFEVISIONARY_INTERFACES__MSG__DETAIL__FIELD_INFORMATION__TRAITS_HPP_
