// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/ROIObservationResultData.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_result_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__init(sick_safevisionary_interfaces__msg__ROIObservationResultData * msg)
{
  if (!msg) {
    return false;
  }
  // task_result
  // result_safe
  // result_valid
  // distance_valid
  // distance_safe
  return true;
}

void
sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(sick_safevisionary_interfaces__msg__ROIObservationResultData * msg)
{
  if (!msg) {
    return;
  }
  // task_result
  // result_safe
  // result_valid
  // distance_valid
  // distance_safe
}

bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__are_equal(const sick_safevisionary_interfaces__msg__ROIObservationResultData * lhs, const sick_safevisionary_interfaces__msg__ROIObservationResultData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // task_result
  if (lhs->task_result != rhs->task_result) {
    return false;
  }
  // result_safe
  if (lhs->result_safe != rhs->result_safe) {
    return false;
  }
  // result_valid
  if (lhs->result_valid != rhs->result_valid) {
    return false;
  }
  // distance_valid
  if (lhs->distance_valid != rhs->distance_valid) {
    return false;
  }
  // distance_safe
  if (lhs->distance_safe != rhs->distance_safe) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__copy(
  const sick_safevisionary_interfaces__msg__ROIObservationResultData * input,
  sick_safevisionary_interfaces__msg__ROIObservationResultData * output)
{
  if (!input || !output) {
    return false;
  }
  // task_result
  output->task_result = input->task_result;
  // result_safe
  output->result_safe = input->result_safe;
  // result_valid
  output->result_valid = input->result_valid;
  // distance_valid
  output->distance_valid = input->distance_valid;
  // distance_safe
  output->distance_safe = input->distance_safe;
  return true;
}

sick_safevisionary_interfaces__msg__ROIObservationResultData *
sick_safevisionary_interfaces__msg__ROIObservationResultData__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationResultData * msg = (sick_safevisionary_interfaces__msg__ROIObservationResultData *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROIObservationResultData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__ROIObservationResultData));
  bool success = sick_safevisionary_interfaces__msg__ROIObservationResultData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__ROIObservationResultData__destroy(sick_safevisionary_interfaces__msg__ROIObservationResultData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__init(sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationResultData * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__ROIObservationResultData *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__ROIObservationResultData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__ROIObservationResultData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__fini(sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence *
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * array = (sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__destroy(sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__are_equal(const sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * lhs, const sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence__copy(
  const sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * input,
  sick_safevisionary_interfaces__msg__ROIObservationResultData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__ROIObservationResultData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__ROIObservationResultData * data =
      (sick_safevisionary_interfaces__msg__ROIObservationResultData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__ROIObservationResultData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROIObservationResultData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
