// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safevisionary_interfaces:msg/ROIObservationSafetyData.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/roi_observation_safety_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__init(sick_safevisionary_interfaces__msg__ROIObservationSafetyData * msg)
{
  if (!msg) {
    return false;
  }
  // invalid_due_to_invalid_pixels
  // invalid_due_to_variance
  // invalid_due_to_overexposure
  // invalid_due_to_underexposure
  // invalid_due_to_temporal_variance
  // invalid_due_to_outside_of_measurement_range
  // invalid_due_to_retro_reflector_interference
  // contamination_error
  // quality_class
  // slot_active
  return true;
}

void
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(sick_safevisionary_interfaces__msg__ROIObservationSafetyData * msg)
{
  if (!msg) {
    return;
  }
  // invalid_due_to_invalid_pixels
  // invalid_due_to_variance
  // invalid_due_to_overexposure
  // invalid_due_to_underexposure
  // invalid_due_to_temporal_variance
  // invalid_due_to_outside_of_measurement_range
  // invalid_due_to_retro_reflector_interference
  // contamination_error
  // quality_class
  // slot_active
}

bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__are_equal(const sick_safevisionary_interfaces__msg__ROIObservationSafetyData * lhs, const sick_safevisionary_interfaces__msg__ROIObservationSafetyData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // invalid_due_to_invalid_pixels
  if (lhs->invalid_due_to_invalid_pixels != rhs->invalid_due_to_invalid_pixels) {
    return false;
  }
  // invalid_due_to_variance
  if (lhs->invalid_due_to_variance != rhs->invalid_due_to_variance) {
    return false;
  }
  // invalid_due_to_overexposure
  if (lhs->invalid_due_to_overexposure != rhs->invalid_due_to_overexposure) {
    return false;
  }
  // invalid_due_to_underexposure
  if (lhs->invalid_due_to_underexposure != rhs->invalid_due_to_underexposure) {
    return false;
  }
  // invalid_due_to_temporal_variance
  if (lhs->invalid_due_to_temporal_variance != rhs->invalid_due_to_temporal_variance) {
    return false;
  }
  // invalid_due_to_outside_of_measurement_range
  if (lhs->invalid_due_to_outside_of_measurement_range != rhs->invalid_due_to_outside_of_measurement_range) {
    return false;
  }
  // invalid_due_to_retro_reflector_interference
  if (lhs->invalid_due_to_retro_reflector_interference != rhs->invalid_due_to_retro_reflector_interference) {
    return false;
  }
  // contamination_error
  if (lhs->contamination_error != rhs->contamination_error) {
    return false;
  }
  // quality_class
  if (lhs->quality_class != rhs->quality_class) {
    return false;
  }
  // slot_active
  if (lhs->slot_active != rhs->slot_active) {
    return false;
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__copy(
  const sick_safevisionary_interfaces__msg__ROIObservationSafetyData * input,
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData * output)
{
  if (!input || !output) {
    return false;
  }
  // invalid_due_to_invalid_pixels
  output->invalid_due_to_invalid_pixels = input->invalid_due_to_invalid_pixels;
  // invalid_due_to_variance
  output->invalid_due_to_variance = input->invalid_due_to_variance;
  // invalid_due_to_overexposure
  output->invalid_due_to_overexposure = input->invalid_due_to_overexposure;
  // invalid_due_to_underexposure
  output->invalid_due_to_underexposure = input->invalid_due_to_underexposure;
  // invalid_due_to_temporal_variance
  output->invalid_due_to_temporal_variance = input->invalid_due_to_temporal_variance;
  // invalid_due_to_outside_of_measurement_range
  output->invalid_due_to_outside_of_measurement_range = input->invalid_due_to_outside_of_measurement_range;
  // invalid_due_to_retro_reflector_interference
  output->invalid_due_to_retro_reflector_interference = input->invalid_due_to_retro_reflector_interference;
  // contamination_error
  output->contamination_error = input->contamination_error;
  // quality_class
  output->quality_class = input->quality_class;
  // slot_active
  output->slot_active = input->slot_active;
  return true;
}

sick_safevisionary_interfaces__msg__ROIObservationSafetyData *
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData * msg = (sick_safevisionary_interfaces__msg__ROIObservationSafetyData *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROIObservationSafetyData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safevisionary_interfaces__msg__ROIObservationSafetyData));
  bool success = sick_safevisionary_interfaces__msg__ROIObservationSafetyData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__destroy(sick_safevisionary_interfaces__msg__ROIObservationSafetyData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__init(sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData * data = NULL;

  if (size) {
    data = (sick_safevisionary_interfaces__msg__ROIObservationSafetyData *)allocator.zero_allocate(size, sizeof(sick_safevisionary_interfaces__msg__ROIObservationSafetyData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safevisionary_interfaces__msg__ROIObservationSafetyData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__fini(sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence *
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * array = (sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence *)allocator.allocate(sizeof(sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__destroy(sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__are_equal(const sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * lhs, const sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence__copy(
  const sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * input,
  sick_safevisionary_interfaces__msg__ROIObservationSafetyData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sick_safevisionary_interfaces__msg__ROIObservationSafetyData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sick_safevisionary_interfaces__msg__ROIObservationSafetyData * data =
      (sick_safevisionary_interfaces__msg__ROIObservationSafetyData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sick_safevisionary_interfaces__msg__ROIObservationSafetyData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sick_safevisionary_interfaces__msg__ROIObservationSafetyData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
